%global relic_commit 3a23142be0a5510a3aa93cd6c76fc59d3fc732a5

%bcond_without tests

%global _lto_cflags %{nil}
%global debug_package %{nil}

Name: bls-dash
Version: 1.1.0
Release: 2%{?dist}.1
Summary: BLS signatures in C++, using the relic toolkit
License: ASL 2.0
URL: https://github.com/dashpay/bls-signatures
Source0: https://github.com/dashpay/bls-signatures/archive/%{version}/bls-dash-%{version}.tar.gz
Patch0: bls-dash-gmp-dynamic.patch
Source1: https://github.com/relic-toolkit/relic/archive/%{relic_commit}/relic-toolkit-%{relic_commit}.tar.gz
BuildRequires: gmp-devel
BuildRequires: cmake3

%description
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%package devel
Summary: BLS signatures in C++, using the relic toolkit
Requires: gmp-devel

%description devel
Implements BLS signatures with aggregation as in Boneh, Drijvers, Neven 2018,
using relic toolkit for cryptographic primitives (pairings, EC, hashing).
The BLS12-381 curve is used.

%prep
%setup -n bls-signatures-%{version}
%patch0 -p1
%{__sed} -i \
    -e 's|GIT_REPOSITORY  *[a-zA-Z:/.-]*|URL "%{SOURCE1}"|' \
    -e 's|GIT_TAG  *[^ )]*||' \
    src/CMakeLists.txt

%build
%{__mkdir} build
cd build
%{cmake3} \
    -DSTLIB=ON \
    -DSHLIB=OFF \
    -DSTBIN=ON \
    -DBUILD_BLS_PYTHON_BINDINGS=0 \
    -DBUILD_BLS_TESTS=1 \
    -DBUILD_BLS_BENCHMARKS=1 \
    -DOPSYS=LINUX \
    -DCMAKE_SYSTEM_NAME=Linux \
    -DWSIZE=%{__isa_bits} \
    -DBUILD_SHARED_LIBS:BOOL=OFF \
    ..

%{?cmake3_build}%{?!cmake3_build:%{make_build}}

%install
cd build
%{?cmake3_install}%{?!cmake3_install:%{make_install}}
if [ '/usr/lib' != '%{_libdir}' ]; then
  %{__mv} '%{buildroot}/usr/lib' '%{buildroot}%{_libdir}'
fi
%{__mkdir_p} %{buildroot}%{_datadir}/cmake
%{__mv} %{buildroot}/usr/cmake %{buildroot}%{_datadir}/cmake/Modules

%check
%if %{with tests}
cd build
%{?__cmake_builddir:cd %{__cmake_builddir}}
./src/runtest
./src/runbench
%endif

%files devel
%license LICENSE
%doc README.md
%{_includedir}/*
%{_libdir}/*
%{_datadir}/cmake/Modules/*
%changelog
* Mon May 24 2021 Oleg Girko <ol@infoserver.lv> - 1.1.0-2
- Don't combine library with statically linked GMP
- Make tests conditional
* Sun May 23 2021 Oleg Girko <ol@infoserver.lv> - 1.1.0-1
- Initial import
